<template>
  <div class="sw-gs-invitation-page" v-if="appointmentInfo" :key="$route.path">
    <SwImage class="sw-gs-invitation-page-image" :src="require('../assets/img/waitingroom.svg')" alt="waitingroom"/>

    <div class="sw-gs-invitation-page-text">
      <h1 class="sw-gs-invitation-page-header">
        <template v-if="!appointmentInfo.status">
          <template v-if="answerInfo === 'accepted'">
            {{ $t('Nice to have you on board!') }}
          </template>
          <template v-else-if="answerInfo === 'maybe'">
            {{ $t('Glad you might be there!') }}
          </template>
          <template v-else-if="answerInfo === 'declined'">
            {{ $t(`Too bad you can't be there.`) }}
          </template>
        </template>
        <template v-else-if="appointmentInfo.status === 'started'">
          {{ $t(`Looks like the presentation has already started.`) }}
        </template>
        <template v-else-if="appointmentInfo.status === 'ended'">
          {{ $t(`It seems that the presentation is already over.`) }}
        </template>
      </h1>
      <template v-if="!appointmentInfo.status">
        <template v-if="['accepted', 'maybe'].includes(answerInfo)">
          <i18n class="sw-gs-invitation-page-desc" path="The presentation will take place on" tag="span">
            <template v-slot:dateFrom>
              <b>{{ formatDate(appointmentInfo.accessibleFrom.date) }} ({{ appointmentInfo.accessibleFrom.timezone }})</b>
            </template>
            <template v-slot:dateTo>
              <b>{{ formatDate(appointmentInfo.accessibleTo.date) }} ({{ appointmentInfo.accessibleTo.timezone }})</b>
            </template>
          </i18n>
        </template>
        <template v-else>
          <span class="sw-gs-invitation-page-desc">
            {{ $t('If you change your mind just use one of the other buttons in the email.') }}
          </span>
        </template>
      </template>
      <template v-else-if="appointmentInfo.status === 'started'">
        <span class="sw-gs-invitation-page-desc">
          {{ $t('Join the presentation using the button below.') }}
        </span>
      </template>
    </div>

    <template v-if="!appointmentInfo.status && ['accepted', 'maybe'].includes(answerInfo)">
      <SwButton class="sw-gs-invitation-action-btn" @click="downloadCalendar">
        {{ $t('Download calendar event') }}
        <SwGsIconTrayUp />
      </SwButton>
    </template>
    <template v-else-if="appointmentInfo.status === 'started'">
      <SwButton class="sw-gs-invitation-action-btn" @click="joinPresentation">
        {{ $t('Join presentation') }}
        <SwGsIconLongArrowRight />
      </SwButton>
    </template>
  </div>
</template>

<script lang="ts">
  import SwButton from "@/components/atoms/SwButton.vue";
  import SwImage from "@/components/atoms/SwImage.vue";
  import { SwGsIconTrayUp, SwGsIconLongArrowRight } from "../components/icons";
  import { useInvitation } from '../logic/composables/useInvitation';
  import { onMounted, ref } from "@vue/composition-api"
  import { formatDate } from "@/helpers"

  const COMPONENT_NAME = 'presentationInvitationPage';

  export default {
    name: COMPONENT_NAME,
    components: {
      SwImage,
      SwButton,
      SwGsIconTrayUp,
      SwGsIconLongArrowRight
    },
    setup(props, { root }) {
      const { token, answer } = root.$route.query;
      const { appointmentId } = root.$route.params;
      const { respondAppointmentInvitation, downloadInvitationFile } = useInvitation();
      const appointmentInfo = ref<any>();
      const answerInfo = ref<string>();

      onMounted(async () => {
        const res = await respondAppointmentInvitation(appointmentId, {
          token,
          answer
        });
        appointmentInfo.value = res.appointment;
        answerInfo.value = res.answer;
      });

      const joinPresentation = () => {
        root.$router.push({
          path: `/presentation/${appointmentId}`
        })
      }

      const downloadCalendar = async () => {
        await downloadInvitationFile(appointmentId, token);
      }
      
      return {
        formatDate,
        answerInfo,
        appointmentInfo,
        joinPresentation,
        downloadCalendar
      }
    },
  };
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  $desktop: 1024px;

  @mixin for-desktop {
    @media screen and (min-width: $desktop) {
      @content;
    }
  }
  .sw-gs-invitation-page {
    position: relative;
    display: flex;
    flex-direction: column;
    align-items: center;
    margin: var(--spacer-xl) auto;
    padding: 0 var(--spacer-base);

    @include for-desktop {
      max-width: 1240px;
      margin: 100px auto;
    }
  }

  .sw-gs-invitation-page-image {
    ::v-deep .sf-image {
      max-width: 100%;
    }
  }

  .sw-gs-invitation-page-header {
    margin-top: var(--spacer-xl);
    margin-bottom: var(--spacer-base);
  }


  .sw-gs-invitation-page-text {
    text-align: center;
  }

  .sw-gs-invitation-page-desc {
    font-size: 18px;
  }

  .sw-gs-invitation-action-btn {
    margin-top: var(--spacer-xl);
    display: flex;
    gap: 12px;
    font-weight: 700;
    font-size: 1rem;
    text-transform: none;
    .sw-gs-icon {
      width: 1rem;
      height: 1rem;
      fill: white;
    }
  }
</style>
